/* FL2PP.H:  Far Lapp to PowerPak Adaptor
*/

#if !defined (FL2PP_H)
#define FL2PP_H

typedef void VOID;
typedef void *PVOID;
typedef unsigned char BYTE;
typedef unsigned short USHORT;
typedef unsigned short *PUSHORT;
typedef unsigned long ULONG;
typedef unsigned short _far *PSEL;

#define APIENTRY                pascal _far
#define ERROR_NOT_ENOUGH_MEMORY 8
#define MAKEP(sel, off) ((PVOID)((((ULONG)(sel))<<16)+(off)))

// Far Lap register structure
typedef struct {
  USHORT es, ds;
  USHORT di, si, bp, sp, bx, dx, cx, ax;  // PUSHA
  USHORT ip, cs, flags;
} REGS16, far *PREGS;

/* PowerPak register structure
typedef struct {
  ULONG di, si, bp;
  ULONG rsvd1;                 // reserved, should be zero
  ULONG bx, dx, cx, ax;
  USHORT flags, es, ds;
  USHORT fs, gs;               // reserved, should be zero
  USHORT ip, cs;               // reserved, ignored
  USHORT sp, ss;
} REALREGS, far *PREALREGS;
*/
typedef struct {
	unsigned long	di,
								si,
								bp,
								always_zero,
								bx,
								dx,
								cx,
								ax;

	unsigned int	flags,
								es,
								ds,
								fs,
								gs,
								ip,
								cs,
								sp,
								ss;
} REALREGS, *PREALREGS;

USHORT DosAllocRealSeg(ULONG size, PUSHORT ppara, PSEL psel);
USHORT APIENTRY DosFreeSeg(USHORT sel);
USHORT _far _cdecl DosRealIntr(USHORT intno, PREGS pregs,
                               ULONG reserved, USHORT words, ...);

#endif
